package indep_set.LaTeX;

import indep_set.root.Root;

public class TikZRootHorizontal extends TikZ {
	
	Root root;
	
	double lvl1length, lvl2length;
	double lvl1step, lvl2step;
	
	double lvl1x;
	double lvl2x;
	double[] lvl1y;
	double[] lvl2y;
	
	String rootName = "0";
	String[][] nodeName;
	
	public TikZRootHorizontal(Root root){
		super();
		this.root = root;
		calculateLengthAndStep();
		calculateCoordinates();
		genNames();
		drawBoundingBox();
		createNodes();
		drawEdges();
		finish();
	}
	
	
	private void calculateLengthAndStep(){
		lvl2step = 0.5;
		lvl2length = lvl2step * (root.lvl2size - 1);
		lvl1step = lvl2step * root.lvl2size / root.lvl1size;
		lvl1length = lvl1step * (root.lvl1size - 1);
	}
	
	private void calculateCoordinates(){
		lvl1x = 1;
		lvl2x = 2;
		lvl1y = new double[root.lvl1size];
		lvl2y = new double[root.lvl2size];
		for (int i = 0; i < root.lvl1size; i++){
			lvl1y[i] = lvl1length / 2 - lvl1step * i;
		}
		for (int i = 0; i < root.lvl2size; i++){
			lvl2y[i] = lvl2length / 2 - lvl2step * i;
		}
	}
	
	private void genNames(){
		nodeName = new String[2][];
		nodeName[0] = new String[root.lvl1size];
		nodeName[1] = new String[root.lvl2size];
		for (int i = 0; i < root.lvl1size; i++){
			nodeName[0][i] = "1" + i;
		}
		for (int i = 0; i < root.lvl2size; i++){
			nodeName[1][i] = "2" + i;
		}
	}
	
	private void drawBoundingBox(){
		addBoundingBox(-.5, 2.5, -lvl2length / 2-.5, lvl2length / 2+.5);
	}
	
	private void createNodes(){
		addNode(rootName, 0, 0, "");
		for (int i = 0; i < root.lvl1size; i++){
			addNode(nodeName[0][i], lvl1x, lvl1y[i], "");
		}
		for (int i = 0; i < root.lvl2size; i++){
			addNode(nodeName[1][i], lvl2x, lvl2y[i], "");
		}
	}
	
	private void drawEdges(){
		for (int i = 0; i < root.lvl1size; i++){
			addDrawEdge(rootName, nodeName[0][i]);
			for (int j : root.level1.get(i)){
				addDrawEdge(nodeName[0][i], nodeName[1][j]);
			}
		}
	}
}
