package indep_set.compound;

import static indep_set.Config.Delta;
import static java.lang.Math.pow;

public class Calculation {	
	
	static final double tolerance = 1e-6;
	
	static double [][] ivalues;
	static double [] i3values;
	
	static public void init(){
		assert(Delta!=0);
		populate();
	}	
	
	private static void populate(){
		ivalues = new double[Delta+1][Delta+1];
		i3values= new double[Delta+1];
		for (int a = 1; a <= Delta; a++){
			i3values[a] = pow(2, 1.0/a);
			for (int b = 1; b <= Delta; b++){
				ivalues[a][b] = pow(pow(2, a) + pow(2,b) - 1, 1.0/a/b);
			}
		}
	}
		
	public static double f(int a, int b){
		assert(a > 0 && b > 0 && a <= Delta && b <= Delta);
		return ivalues[a][b];
	}
	
	//used for 23-edges (u, v), where a the degree of u
	public static double f3(int a){
		return f(a, Delta);
	}

}
