package indep_set.root;

import java.util.ArrayList;
import java.util.List;

/**
 * A root consists of all level 0, 1, 2 vertices as well as edges
 * set up between these vertices.
 */
public class Root {
	public List<List<Integer>> level1;
	public List<List<Integer>> level2;
	public String code;
	
	public int lvl1size, lvl2size;
	
	public Root(int lvl1size, int lvl2size){
		this.lvl1size =lvl1size;
		this.lvl2size =lvl2size;
		level1 = new ArrayList<List<Integer>>(lvl1size);
		level2 = new ArrayList<List<Integer>>(lvl2size);
		for (int i = 0; i < lvl1size; i++){
			level1.add(new ArrayList<Integer>());
		}
		for (int i = 0; i < lvl2size; i++){
			level2.add(new ArrayList<Integer>());
		}
	}
	
	public int lvl1outDegree(int a){
		return level1.get(a).size();
	}
	
	public int lvl2inDegree(int a){
		return level2.get(a).size();
	}
	
	/**
	 * Addes an edge between vertex a in lvl1 and vertex b in lvl2
	 */
	public void addEdge(int a, int b){
		level1.get(a).add(b);
		level2.get(b).add(a);
	}
	
}
