package indep_set.run;


import indep_set.Config;
import indep_set.gen_root_code.AllRootCodes;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

/**
 * Generates all possible root configurations. Outputs to rootCodes.txt
 */
public class RunGenerateRootCodes {
		
	File outFile;
	
	public RunGenerateRootCodes(File outFile){
		this.outFile = outFile;
	}
	
	public void run() throws IOException {
		PrintWriter writer = null;
		try {
			writer = new PrintWriter(new BufferedWriter(new FileWriter(outFile)));
			writer.println(Config.configText());
			if (Config.root_node_min){
				for (int i = 1; i < Config.Delta; i++){
					AllRootCodes allCodes = new AllRootCodes(i, writer);
					allCodes.generateAllRootCodes();
				}
			} else{
				for (int i = 1; i <= Config.Delta; i++){
					AllRootCodes allCodes = new AllRootCodes(i, writer);
					allCodes.generateAllRootCodes();
				}
			}
			
            
        } finally {
            if (writer !=null){
            	writer.close();
            }
        }
	}	

	public static String outFileName(){
		return "rootCodes.txt";
	}
	
	public static void runRegular(){
		File outFile = new File(outFileName());
		try{
			new RunGenerateRootCodes(outFile).run();
		} catch (Exception e){
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args) throws IOException {
		runRegular();
	}
	
}
